      program ttime
c
c     Travel time calculation based on iasp91 model
c       Coded by T. Shibutani
c       Ver. 1996-11-20
c
      parameter (ndmax=6400)
c
      implicit real*8 (a-h,o-z)
      dimension r(ndmax),v(ndmax,2)
      character outname*64, ttname*64
c
      open(11,file='./iasp91.mdl',status='old')
      write(6,'(" Output Table Name: ",$)') 
      read(5,'(a)') outname
      len=lofw(outname)
      write(ttname,'(a,".tbl",a1)') outname(1:len),char(0)
      open(22,file=ttname,status='unknown')
c
c
c---  parameters
c
      eee=1.d-10
      pi=3.141592654
      rad=pi/180.0
      ra=6371.0
      rcmb=3482.0
c
c---  read iasp91.mdl
c
      jd=0
  100 continue
      jd=jd+1
      read(11,7000,end=110) r(jd),v(jd,1),v(jd,2)
 7000 format(f6.1,2f10.6)
      go to 100
  110 continue
      nd=jd-1
      r(nd+1)=0.1
c
c---  source depth & source layer
c
      write(6,'(" Source Depth: ",$)')
      read(5,*) deps
      rs=ra-deps
c
c---  P or S
c
      write(6,'(" Wave Type (P=1, S=2): ",$)')
      read(5,*) ips
c
c---  emergent angles
c
      write(6,'(" Range of Emergent Angle(ea1,ea2,ed): ",$)')
      read(5,*) ea1,ea2,ed
c
      write(6,'(6x,"EA",9x,"D",9x,"TT",9x, "RT",8x,"p")')
c
      ne=int((ea2-ea1)/ed)+1
      do ia=1,ne
        ea=ea1+float(ia-1)*ed
        if (ea.lt.90.0) then
           call dwsrc(ea,rs,ips,p,nd,r,v)
        else
           call upsrc(ea,rs,ips,p,nd,r,v)
        end if
c        write(6,*) 'p=',p
c
c-----  Here you can call desired subroutine(s) 
c       for travel time calculation
c
c        call tnray(del,tt,rt,p,r1,r2,ips,nd,r,v,eee,nerr)
c        call dwray(del,tt,p,r1,r2,ips,nd,r,v,eee,nerr)
c        call upray(del,tt,p,r1,r2,ips,nd,r,v,eee,nerr)
c
        del=0.0
        tt=0.0
c
c---    for turning ray
c
        call tnray(del,tt,rt,p,rs,ra,ips,nd,r,v,eee,nerr)
c
c---    for reflected ray at CMB
c
c        call dwray(del,tt,p,rs,rcmb,ips,nd,r,v,eee,nerr)
c        ips=1
c        call upray(del,tt,p,rcmb,ra,ips,nd,r,v,eee,nerr)
c
c---    for depth phase pP
c
c        call upray(del,tt,p,rs,ra,ips,nd,r,v,eee,nerr)
c        ips=1
c        call tnray(del,tt,rt,p,ra,ra,ips,nd,r,v,eee,nerr)
c
c---    for core phase SKKS
c
c        call dwray(del,tt,p,rs,rcmb,ips,nd,r,v,eee,nerr)
c        ips=1
c        call tnray(del,tt,rt,p,rcmb,rcmb,ips,nd,r,v,eee,nerr)
c        ips=1
c        call tnray(del,tt,rt,p,rcmb,rcmb,ips,nd,r,v,eee,nerr)
c        ips=2
c        call upray(del,tt,p,rcmb,ra,ips,nd,r,v,eee,nerr)
c---
c        
        if (nerr.ne.0) then
           write(6,8000) ea
           write(22,8000) ea
 8000      format(f10.2,7x,'NaN',8x,'NaN',8x,'NaN',7x,'NaN')
        else
	   pp=p*rad
	   if (del.gt.180.) del=360.-del
           write(6,8010) ea,del,tt,rt,pp
           write(22,8010) ea,del,tt,rt,pp
 8010      format(2f10.2,2f11.2,f10.3)
        end if
c
      end do
c
      stop
      end
